/* ----------------------------------------------------------------------------
 * This file was automatically generated by SWIG (http://www.swig.org).
 * Version 1.3.36
 *
 * Do not make changes to this file unless you know what you are doing--modify
 * the SWIG interface file instead.
 * ----------------------------------------------------------------------------- */


using System;
using System.Runtime.InteropServices;

public class vectorRing : IDisposable, System.Collections.IEnumerable {
  private HandleRef swigCPtr;
  protected bool swigCMemOwn;

  internal vectorRing(IntPtr cPtr, bool cMemoryOwn) {
    swigCMemOwn = cMemoryOwn;
    swigCPtr = new HandleRef(this, cPtr);
  }

  internal static HandleRef getCPtr(vectorRing obj) {
    return (obj == null) ? new HandleRef(null, IntPtr.Zero) : obj.swigCPtr;
  }

  ~vectorRing() {
    Dispose();
  }

  public virtual void Dispose() {
    lock(this) {
      if(swigCPtr.Handle != IntPtr.Zero && swigCMemOwn) {
        swigCMemOwn = false;
        openbabelPINVOKE.delete_vectorRing(swigCPtr);
      }
      swigCPtr = new HandleRef(null, IntPtr.Zero);
      GC.SuppressFinalize(this);
    }
  }

  public vectorRing(System.Collections.ICollection c) : this() {
    if (c == null)
      throw new ArgumentNullException("c");
    foreach (OBRing element in c) {
      this.Add(element);
    }
  }

  public bool IsFixedSize {
    get {
      return false;
    }
  }

  public bool IsReadOnly {
    get {
      return false;
    }
  }

  public OBRing this[int index]  {
    get {
      return getitem(index);
    }
    set {
      setitem(index, value);
    }
  }

  public int Capacity {
    get {
      return (int)capacity();
    }
    set {
      if (value < size())
        throw new ArgumentOutOfRangeException("Capacity");
      reserve((uint)value);
    }
  }

  public int Count {
    get {
      return (int)size();
    }
  }

  public bool IsSynchronized {
    get {
      return false;
    }
  }

  public void CopyTo(System.Array array) {
    CopyTo(0, array, 0, this.Count);
  }

  public void CopyTo(System.Array array, int arrayIndex) {
    CopyTo(0, array, arrayIndex, this.Count);
  }

  public void CopyTo(int index, System.Array array, int arrayIndex, int count) {
    if (array == null)
      throw new ArgumentNullException("array");
    if (index < 0)
      throw new ArgumentOutOfRangeException("index", "Value is less than zero");
    if (arrayIndex < 0)
      throw new ArgumentOutOfRangeException("arrayIndex", "Value is less than zero");
    if (count < 0)
      throw new ArgumentOutOfRangeException("count", "Value is less than zero");
    if (array.Rank > 1)
      throw new ArgumentException("Multi dimensional array.");
    if (index+count > this.Count || arrayIndex+count > array.Length)
      throw new ArgumentException("Number of elements to copy is too large.");
    for (int i=0; i<count; i++)
      array.SetValue(getitemcopy(index+i), arrayIndex+i);
  }

  // Type-safe version of IEnumerable.GetEnumerator
  System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator() {
    return new vectorRingEnumerator(this);
  }

  public vectorRingEnumerator GetEnumerator() {
    return new vectorRingEnumerator(this);
  }

  // Type-safe enumerator
  /// Note that the IEnumerator documentation requires an InvalidOperationException to be thrown
  /// whenever the collection is modified. This has been done for changes in the size of the
  /// collection but not when one of the elements of the collection is modified as it is a bit
  /// tricky to detect unmanaged code that modifies the collection under our feet.
  public sealed class vectorRingEnumerator : System.Collections.IEnumerator {
    private vectorRing collectionRef;
    private int currentIndex;
    private object currentObject;
    private int currentSize;

    public vectorRingEnumerator(vectorRing collection) {
      collectionRef = collection;
      currentIndex = -1;
      currentObject = null;
      currentSize = collectionRef.Count;
    }

    // Type-safe iterator Current
    public OBRing Current {
      get {
        if (currentIndex == -1)
          throw new InvalidOperationException("Enumeration not started.");
        if (currentIndex > currentSize - 1)
          throw new InvalidOperationException("Enumeration finished.");
        if (currentObject == null)
          throw new InvalidOperationException("Collection modified.");
        return (OBRing)currentObject;
      }
    }

    // Type-unsafe IEnumerator.Current
    object System.Collections.IEnumerator.Current {
      get {
        return Current;
      }
    }

    public bool MoveNext() {
      int size = collectionRef.Count;
      bool moveOkay = (currentIndex+1 < size) && (size == currentSize);
      if (moveOkay) {
        currentIndex++;
        currentObject = collectionRef[currentIndex];
      } else {
        currentObject = null;
      }
      return moveOkay;
    }

    public void Reset() {
      currentIndex = -1;
      currentObject = null;
      if (collectionRef.Count != currentSize) {
        throw new InvalidOperationException("Collection modified.");
      }
    }
  }

  public void Clear() {
    openbabelPINVOKE.vectorRing_Clear(swigCPtr);
  }

  public void Add(OBRing x) {
    openbabelPINVOKE.vectorRing_Add(swigCPtr, OBRing.getCPtr(x));
    if (openbabelPINVOKE.SWIGPendingException.Pending) throw openbabelPINVOKE.SWIGPendingException.Retrieve();
  }

  private uint size() {
    uint ret = openbabelPINVOKE.vectorRing_size(swigCPtr);
    return ret;
  }

  private uint capacity() {
    uint ret = openbabelPINVOKE.vectorRing_capacity(swigCPtr);
    return ret;
  }

  private void reserve(uint n) {
    openbabelPINVOKE.vectorRing_reserve(swigCPtr, n);
  }

  public vectorRing() : this(openbabelPINVOKE.new_vectorRing__SWIG_0(), true) {
  }

  public vectorRing(int capacity) : this(openbabelPINVOKE.new_vectorRing__SWIG_1(capacity), true) {
    if (openbabelPINVOKE.SWIGPendingException.Pending) throw openbabelPINVOKE.SWIGPendingException.Retrieve();
  }

  private OBRing getitemcopy(int index) {
    OBRing ret = new OBRing(openbabelPINVOKE.vectorRing_getitemcopy(swigCPtr, index), true);
    if (openbabelPINVOKE.SWIGPendingException.Pending) throw openbabelPINVOKE.SWIGPendingException.Retrieve();
    return ret;
  }

  private OBRing getitem(int index) {
    OBRing ret = new OBRing(openbabelPINVOKE.vectorRing_getitem(swigCPtr, index), false);
    if (openbabelPINVOKE.SWIGPendingException.Pending) throw openbabelPINVOKE.SWIGPendingException.Retrieve();
    return ret;
  }

  private void setitem(int index, OBRing val) {
    openbabelPINVOKE.vectorRing_setitem(swigCPtr, index, OBRing.getCPtr(val));
    if (openbabelPINVOKE.SWIGPendingException.Pending) throw openbabelPINVOKE.SWIGPendingException.Retrieve();
  }

  public void AddRange(vectorRing values) {
    openbabelPINVOKE.vectorRing_AddRange(swigCPtr, vectorRing.getCPtr(values));
    if (openbabelPINVOKE.SWIGPendingException.Pending) throw openbabelPINVOKE.SWIGPendingException.Retrieve();
  }

  public vectorRing GetRange(int index, int count) {
    IntPtr cPtr = openbabelPINVOKE.vectorRing_GetRange(swigCPtr, index, count);
    vectorRing ret = (cPtr == IntPtr.Zero) ? null : new vectorRing(cPtr, true);
    if (openbabelPINVOKE.SWIGPendingException.Pending) throw openbabelPINVOKE.SWIGPendingException.Retrieve();
    return ret;
  }

  public void Insert(int index, OBRing x) {
    openbabelPINVOKE.vectorRing_Insert(swigCPtr, index, OBRing.getCPtr(x));
    if (openbabelPINVOKE.SWIGPendingException.Pending) throw openbabelPINVOKE.SWIGPendingException.Retrieve();
  }

  public void InsertRange(int index, vectorRing values) {
    openbabelPINVOKE.vectorRing_InsertRange(swigCPtr, index, vectorRing.getCPtr(values));
    if (openbabelPINVOKE.SWIGPendingException.Pending) throw openbabelPINVOKE.SWIGPendingException.Retrieve();
  }

  public void RemoveAt(int index) {
    openbabelPINVOKE.vectorRing_RemoveAt(swigCPtr, index);
    if (openbabelPINVOKE.SWIGPendingException.Pending) throw openbabelPINVOKE.SWIGPendingException.Retrieve();
  }

  public void RemoveRange(int index, int count) {
    openbabelPINVOKE.vectorRing_RemoveRange(swigCPtr, index, count);
    if (openbabelPINVOKE.SWIGPendingException.Pending) throw openbabelPINVOKE.SWIGPendingException.Retrieve();
  }

  public static vectorRing Repeat(OBRing value, int count) {
    IntPtr cPtr = openbabelPINVOKE.vectorRing_Repeat(OBRing.getCPtr(value), count);
    vectorRing ret = (cPtr == IntPtr.Zero) ? null : new vectorRing(cPtr, true);
    if (openbabelPINVOKE.SWIGPendingException.Pending) throw openbabelPINVOKE.SWIGPendingException.Retrieve();
    return ret;
  }

  public void Reverse() {
    openbabelPINVOKE.vectorRing_Reverse__SWIG_0(swigCPtr);
  }

  public void Reverse(int index, int count) {
    openbabelPINVOKE.vectorRing_Reverse__SWIG_1(swigCPtr, index, count);
    if (openbabelPINVOKE.SWIGPendingException.Pending) throw openbabelPINVOKE.SWIGPendingException.Retrieve();
  }

  public void SetRange(int index, vectorRing values) {
    openbabelPINVOKE.vectorRing_SetRange(swigCPtr, index, vectorRing.getCPtr(values));
    if (openbabelPINVOKE.SWIGPendingException.Pending) throw openbabelPINVOKE.SWIGPendingException.Retrieve();
  }

}
